package com.daniminguet.videogameadvisor.dao;

import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.util.ResourceUtils;

import com.daniminguet.videogameadvisor.model.Videogame;

public class UtilVideogameFileReader {
	public static List<Videogame> readFile(final String path, final String separator, final String listSeparator) {
		List<Videogame> result = new ArrayList<Videogame>();
		
		try {
			// @formatter:off
			result = Files
						.lines(Paths.get(ResourceUtils.getFile(path).toURI()))
						.skip(1)
						.map(line -> {
							String[] values = line.split(separator);
							return new Videogame(Long.parseLong(values[0]), values[1], values[2],
											Arrays.asList(values[3].split(listSeparator)), values[4], values[5]);
					}).collect(Collectors.toList());
 			// @formatter:on


		} catch (Exception e) {
			System.err.println("Error de lectura del fichero de datos: imdb_data");
			System.exit(-1);
		}
		
		return result;
	}
}
