package com.daniminguet.videogameadvisor.dao;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.daniminguet.videogameadvisor.config.AppConfig;
import com.daniminguet.videogameadvisor.model.Videogame;

@Repository
public class VideogameDaoImplMemory implements VideogameDao {
	
	public List<Videogame> videogames = new ArrayList<Videogame>();
	
	@Autowired
	private AppConfig appConfig;
	
	@PostConstruct
	public void init() {
		videogames = UtilVideogameFileReader.readFile(appConfig.getFile(), appConfig.getSeparator(), appConfig.getListSeparator());
	}

	public Videogame findById(long id) {
		Optional<Videogame> result = videogames.stream().filter(vg -> vg.getId() == id).findFirst();
		return result.orElse(null);
	}
	
	public Collection<Videogame> findAll() {
		return videogames;
	}

	public void insert(Videogame videogame) {
		videogames.add(videogame);
	}

	public void edit(Videogame videogame) {
		int i = getIndexOf(videogame.getId());
		if(i != -1) {
			videogames.set(i, videogame);
		}
	}

	public void delete(long id) {
		int i = getIndexOf(id);
		if(i != -1) {
			videogames.remove(i);
		}
	}
	
	private int getIndexOf(long id) {
		boolean found = false;
		int i = 0;
		
		while(!found && i < videogames.size()) {
			if(videogames.get(i).getId() == id) {
				found = true;
			} else {
				i++;
			}
		}
		
		return (found) ? i : -1;
	}

}
